/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * xesam-glib
 * Copyright (C) Mikkel Kamstrup Erlandsen 2008 <mikkel.kamstrup@gmail.com>
 * 
 * xesam-glib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * xesam-glib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with xesam-glib.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#ifndef __XESAM_G_XML_QUERY_BUILDER_H__
#define __XESAM_G_XML_QUERY_BUILDER_H__

#include <glib.h>
#include <glib-object.h>
#include "xesam-glib/xesam-g-query.h"
#include "xesam-glib/xesam-g-query-builder.h"
#include "xesam-glib/xesam-g-query-token.h"

G_BEGIN_DECLS


#define XESAM_TYPE_G_XML_QUERY_BUILDER (xesam_g_xml_query_builder_get_type ())
#define XESAM_G_XML_QUERY_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XESAM_TYPE_G_XML_QUERY_BUILDER, XesamGXmlQueryBuilder))
#define XESAM_G_XML_QUERY_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XESAM_TYPE_G_XML_QUERY_BUILDER, XesamGXmlQueryBuilderClass))
#define XESAM_IS_G_XML_QUERY_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XESAM_TYPE_G_XML_QUERY_BUILDER))
#define XESAM_IS_G_XML_QUERY_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XESAM_TYPE_G_XML_QUERY_BUILDER))
#define XESAM_G_XML_QUERY_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XESAM_TYPE_G_XML_QUERY_BUILDER, XesamGXmlQueryBuilderClass))

typedef struct _XesamGXmlQueryBuilder XesamGXmlQueryBuilder;
typedef struct _XesamGXmlQueryBuilderClass XesamGXmlQueryBuilderClass;
typedef struct _XesamGXmlQueryBuilderPrivate XesamGXmlQueryBuilderPrivate;

struct _XesamGXmlQueryBuilder {
	GObject							parent;
	XesamGXmlQueryBuilderPrivate	*priv;
};
struct _XesamGXmlQueryBuilderClass {
	GObjectClass					parent;
};

GType 					xesam_g_xml_query_builder_get_type		(void);

XesamGXmlQueryBuilder* 	xesam_g_xml_query_builder_new			(void);

gchar* 					xesam_g_xml_query_builder_get_xml		(XesamGXmlQueryBuilder*	self);

XesamGQuery*			xesam_g_xml_query_builder_get_query		(XesamGXmlQueryBuilder*	self);

G_END_DECLS

#endif
